UNIT Widget;
INTERFACE
USES
    os2def,os2pmapi,SysUtils,Classes;
{$I rp.inc}
CONST
    TB_SEPARATOR    = $7001; (* Separator Item ID *)
    TB_BUBBLEID     = $7002; (* Bubble help window ID *)
    cTextSize=64;
    PaneClientClass='PaneClient';
    UEAppName='RayTracer By Path Traceing'+'$Revision: 4.1 $';
    ppFont     :pchar   ='9.WarpSans';
    WidgetTimerID=128;

CONST
    TabFrameWidth=1;
    TabTopPannelWidth=3;
    TabTopWidth=TabFrameWidth+TabTopPannelWidth;
    TabBottomWidth=2;
    TabFramePannelID=1;
CONST
    DrawMargin=1;
    DrawFrameWidth=TabFrameWidth;



TYPE
    (*pane propty*)
    PanePropertytype=(TopPane,BottomPane);
    (* Toolbar data *)
    ToolBarData  = RECORD
        NuID:ULong;
        cText   :String[cTextSize];
    END;
    pToolbarData = ^ToolBarData;

    TPaneWindowClass=CLASS;

    TabPaneWindowClass=CLASS
        hwndTabPane:hwnd;
        TabAry:ARRAY[0..255] OF RECORD
                        TabName:string;
                        TabID:INTEGER;
                        xLeft:INTEGER;
                        Width:INTEGER;
                    END;
        TabMax:INTEGER;
        ActiveTabIndex:INTEGER;
        ParentClass:TPaneWindowClass;
        constructor Create(P:TPaneWindowClass;owner:hwnd);
        PROCEDURE AddTab(FN:string;ID:INTEGER);
        PROCEDURE DeleteTab(id:INTEGER);
        PROCEDURE SetActive(id:INTEGER);
        PROCEDURE RenameActiveTab(NewStr:string);
        FUNCTION DrawTab(ps:hps;rect:RectL;suffix:INTEGER):INTEGER;
        PROCEDURE DrawTabPane(window:hwnd);virtual;
        FUNCTION ClickTabNumber(pt:PointL):INTEGER;
    END;

    TPaneWindowClass=CLASS
        hwndFrame,hwndClient,
        hwndStatus,hwndToolpane:hwnd;
        hwndBubble:hwnd;
        bubbleClient:hwnd;
        OldProc:FNWP;
        TabPane:TabPaneWindowClass;
        constructor Create(AN:HAB);virtual;
        PROCEDURE CreateToolbar(pToolbar:pToolbarData);virtual;
        PROCEDURE CreateTab;virtual;
        FUNCTION MsgHandler(window:hwnd;
                            Msg:ULong;
                            mp1,mp2:MParam):MResult;virtual;//OverRide
        FUNCTION PaneHandler(window:hwnd;
                             msg:ULong;
                             mp1,mp2:MParam):MResult;virtual;
        PROCEDURE ActiveToolbarButton(b:BOOLEAN);virtual;
    PROTECTED
        TBList:TList;
    END;

    ToolButtonClass=CLASS
        ToolbarOldProc:FNWP;
        NuID:ULong;
        cText:String[cTextSize];
        isCapture,isHilight:BOOLEAN;
        isStartTimer:BOOLEAN;
        isActive:BOOLEAN;
        hwndFrame,window:hwnd;
        PW:TPaneWindowClass;
        constructor Create(rcID:ULong;
                           st:string;
                           OwnerWnd:hwnd;
                           xPos:INTEGER);virtual;
        FUNCTION TBHandler(window:hwnd;Msg:ULong;Mp1,Mp2:MParam):MResult;
                                                                  virtual;
    END;




IMPLEMENTATION
CONST
    ueToolPane='ueToolPane';
    ueTabPane='ueTabPane';

    idStatusBar=21000;
    idToolPane=22000;

    ButtonDepth=1;
    SepWidth=8;
    TBSize=32;

FUNCTION ToolPaneProc( Window: HWnd;
                       Msg   : ULong;
                       mp1   : MParam;
                       mp2   : MParam ) : mResult;cdecl;
VAR
    ps:HPS;
    rect:RectL;
BEGIN
    CASE msg OF
        wm_paint:BEGIN
            ps:=WinBeginPaint(window,0,@rect);
            WinFillRect(ps,Rect,SYSCLR_MENU);
            WinEndPaint(ps);
        END;
        ELSE
            result := WinDefWindowProc( Window,Msg,mp1,mp2);
    END;
END;

FUNCTION TabPaneProc( Window: HWnd;
                       Msg     : ULong;
                       mp1   : MParam;
                       mp2   : MParam ) : mResult;cdecl;
VAR
    ps:HPS;
    rect,wRect:RectL;
    TabWindow:TabPaneWindowClass;
    i:INTEGER;
    pt:points;
    pt1:pointL;
BEGIN
    TabWindow:=TabPaneWindowClass(WinQueryWindowULONG(window,QWL_USER));
    CASE msg OF
        wm_paint:BEGIN
            TabWindow.DrawTabpane(window);
        END;
        WM_BUTTON1UP:BEGIN
            pt:=points(mp1);
            pt1.x:=pt.x;
            pt1.y:=pt.y;
            i:=TabWindow.ClickTabNumber(pt1);
        END;
        ELSE BEGIN
            result := WinDefWindowProc( Window,Msg,mp1,mp2);
        END;
    END;
END;



FUNCTION TPaneWindowClass.PaneHandler(window:hwnd;
                                      msg:ULong;
                                      mp1,mp2:MParam):MResult;
var
    ps:HPS;
    PaneRect:RECTL;
    PaintRect:RectL;
    
    PROCEDURE WMChar;
    LABEL
        LSC;
    VAR
        fsFlags,ascii,Scan,virtkey:SmallWord;
        REP:BYTE;
    BEGIN
        fsFlags := CharMsgMp1(MP1).fs ;
        REP := CharMsgMp1(Mp1).cRepeat;
        Scan:= CharMsgMp1(Mp1).ScanCode;
        Ascii := CharMsgMp2(MP2).CHR;
        virtkey := CharMsgMp2(MP2).VKey;

        IF fsFlags AND KC_KEYUP <> 0 THEN EXIT;

        IF fsFlags AND KC_CHAR <> 0 THEN BEGIN
            IF (ascii < 32) OR (fsFlags AND KC_CTRL <> 0) THEN GOTO LSC;
            IF (fsFlags AND KC_VIRTUALKEY <> 0)
                AND (fsFlags AND KC_SHIFT <> 0) THEN
                        GOTO LSC;    {numerical block}

            //CharEvent(Ascii,Rep);
        END
        ELSE BEGIN
    lsc:
            IF fsFlags AND KC_VIRTUALKEY <> 0 THEN
                Ascii := virtkey
            ELSE BEGIN
                IF (Lo(Ascii)=$82) AND (Hi(Ascii)>$80) AND (Hi(Ascii)<$9B) THEN
                    Ascii:=Hi(Ascii)-$20;
            END;
            //ScanEvent(fsFlags,Ascii,Rep);
        END;
    END;(**wm_char**)
begin
    CASE msg OF
        WM_CHAR:
            WMChar;
        WM_PAINT:BEGIN
            ps:= WinBeginPaint(window,NULLHANDLE,@PaintRect);
            WinFillRect(ps,PaintRect,clr_white);
            WinEndPaint(ps);
        END;
        ELSE
            result:=WinDefWindowProc(Window, msg, mp1, mp2);
  END;
end;

FUNCTION PaneClientProc(Window:HWnd;Msg:ULong; Mp1,Mp2:MParam):MResult;cdecl;
VAR
    PaneWindow:TPaneWindowClass;
BEGIN
    PaneWindow:= TPaneWindowClass(WinQueryWindowULONG(
                                     WinQueryWindow(window,QW_PARENT),
                                     QWL_USER ));
    IF PaneWindow=Nil then
        Result:=WinDefWindowProc(Window, msg, mp1, mp2)
    else
        result:=PaneWindow.PaneHandler(Window,msg,mp1,mp2);
END;

FUNCTION NewFrameProc( Window: HWnd;Msg:ULong;mp1,mp2:MParam):mResult;cdecl;
TYPE
    SWPArray=ARRAY[0..255] OF SWP;
    pSWPA=^SWPArray;
VAR
    PaneWindow:TPaneWindowClass;
    itemCount:UShort;
    usClient,usMenu:INTEGER;
    pSW:PSWPA;
BEGIN
    PaneWindow:= TPaneWindowClass(WinQueryWindowULONG( window, QWL_USER ));
    CASE Msg OF
        WM_QUERYFRAMECTLCOUNT:BEGIN
            itemCount:=SHORT1FROMMR(PaneWindow.OldProc(window,msg,mp1,mp2));
            //count frame controls
            Inc(ItemCount);
            IF PaneWindow.TabPane<>Nil then Inc(ItemCount);
            result:= MRESULT(itemCount );//add 1 FOR NEW statusbar
        END;
        WM_FORMATFRAME :BEGIN
            usClient := 0;
            usMenu := 0;
            itemCount:=SHORT1FROMMR(PaneWindow.OldProc(window,Msg,mp1,mp2 ));

            pSW := PSWPA(mp1);
            WHILE pSW^[usClient].wnd <>WinWindowFromID(window, FID_CLIENT) DO
                Inc(usClient);
            WHILE pSW^[usMenu].Wnd <>WinWindowFromID(window, FID_MENU) DO
                inc(usMenu);
            IF PaneWindow.TabPane<>Nil THEN BEGIN

                pSW^[itemCount].wnd := PaneWindow.hwndStatus;// Window handle
                pSW^[itemCount].fl:= SWP_SIZE OR SWP_MOVE;  // SWP_SIZE style flag
                pSW^[itemCount].cy:= pSW^[usMenu].cy
                                        +TabTopWidth+TabBottomWidth; // Heigth
                pSW^[itemCount].cx:= pSW^[usMenu].cx ;      // width is menu width
                pSW^[itemCount].x := pSW^[usClient].x ;       // XPOS IN FRAME
                pSW^[itemCount].y := pSW^[usClient].y ;       // YPOS IN FRAME
                pSW^[itemCount].hwndInsertBehind := HWND_TOP ;
               // On which window (ONTOP)

               // adjust client window size FOR 2nd menu
               // IF NOT, the client window will be placed over the statusbar
               pSW^[usClient].cy:= pSW^[usClient].cy - pSW^[itemCount].cy ;
               pSW^[usClient].y := pSW^[itemCount].y + pSW^[itemCount].cy ;
               // return total count OF frame controls
               inc(ItemCount);
            END;

            pSW^[itemCount].wnd := PaneWindow.hwndToolpane; // Window handle
            pSW^[itemCount].fl:= SWP_SIZE OR SWP_MOVE;  // SWP_SIZE style flag
            pSW^[itemCount].cy:= TBSize;       // Heigth menu hoogte
            pSW^[itemCount].cx:= pSW^[usMenu].cx ;      // width is menu width
            pSW^[itemCount].x := pSW^[usClient].x ;       // XPOS IN FRAME
            pSW^[itemCount].y := pSW^[usClient].cy+pSW^[usClient].y-TBSize;
                                                        // YPOS IN FRAME
            pSW^[itemCount].hwndInsertBehind := HWND_TOP ;
           // On which window (ONTOP)

           pSW^[usClient].cy:= pSW^[usClient].cy - pSW^[itemCount].cy ;
           inc(ItemCount);

           result:=MRFROMSHORT(itemCount );
       END;
       ELSE
           result := PaneWindow.MsgHandler( window,Msg,mp1,mp2);
    END; { Case ulMsg }
END; { NewFrameProc }

constructor TPaneWindowClass.Create(AN:HAB);
VAR
    ulFlags:ULong;
    MenuHandle:hwnd;
BEGIN
    TBList:=TList.Create;
    WinRegisterClass(An,ueToolPane,ToolPaneProc,CS_SIZEREDRAW,sizeof(ULONG));
    WinRegisterClass(An,ueTabPane,TabPaneProc,CS_SIZEREDRAW,sizeof(ULONG));
    WinRegisterClass(AN,
                     PaneClientClass,
                     PaneClientProc,
                     CS_SIZEREDRAW,
                     sizeof(ULONG));
    ulFlags := FCF_TITLEBAR OR FCF_SYSMENU OR FCF_ICON OR FCF_SHELLPOSITION
           OR FCF_SIZEBORDER OR FCF_MINMAX OR FCF_TASKLIST;

    {************************************************************}
    {* create frame window                                      *}
    {************************************************************}

    hwndFrame := WinCreateStdWindow( HWND_DESKTOP,
                                     WS_VISIBLE OR WS_ANIMATE,
                                     ulFlags,
                                     PaneClientClass,
                                     UEAppName,
                                     0,
                                     NULLHANDLE,
                                     MAIN_FRAME,
                                     @hwndClient);
    @OldProc := WinSubclassWindow( hwndFrame,NewFrameProc );

    WinSetWindowPtr( hwndFrame,QWL_USER,self);
    MenuHandle:=WinLoadMenu(hwndFrame,NULLHANDLE,MAIN_FRAME);
    TabPane:=Nil;
END;

PROCEDURE TPaneWindowClass.CreateToolbar(pToolbar:pToolbarData);
VAR
    xPos:INTEGER;
    TB:ToolButtonClass;
BEGIN
     hwndToolpane:= WinCreateWindow(hwndFrame,
                                  ueToolPane,
                                  'ToolPane',
                                  WS_VISIBLE,
                                  0, 0, 0, 0,
                   // client window has no size OR position at this point
                                  hwndFrame,         // Owner handle
                                  HWND_TOP,          // Z-order ontop
                                  idToolPane,         // Window ID
                                  NIL,                 // Control
                                  NIL);             // Presentation Parameters
    xPos:=0;
    WHILE pToolbar^.NuID<>0 DO BEGIN
        TB:=ToolButtonClass.Create(pToolBar^.NuID,
                                   pToolBar^.cText,
                                   hwndToolPane,
                                   xPos);
        TB.hwndFrame:=hwndFrame;
        TB.PW:=Self;
        TBList.Add(TB);
        IF pToolbar^.NuID<>TB_SEPARATOR THEN
            Inc(xPos,TBSize)
        ELSE
            Inc(xPos,SepWidth);
        Inc(pToolbar);
    END;
    hwndBubble:=0;
END;
PROCEDURE TPaneWindowClass.CreateTab;
BEGIN
    TabPane:=TabPaneWindowClass.Create(self,hwndFrame);
    hwndStatus:= WinCreateWindow(
                    hwndFrame,
                    ueTabPane,
                    'TabBar',
                    WS_VISIBLE,
                    0, 0, 0, 0,
                   // client window has no size OR position at this point
                    hwndFrame,         // Owner handle
                    HWND_TOP,          // Z-order ontop
                    idStatusBar,         // Window ID
                    NIL,                 // Control
                    NIL);             // Presentation Parameters
    TabPane.hwndTabPane:=hwndStatus;
    WinSetWindowPtr(hwndStatus,QWL_USER,TabPane);
END;

FUNCTION TPaneWindowClass.MsgHandler(window:hwnd;
                                     Msg:ULong;
                                     mp1,mp2:MParam):MResult;
BEGIN
    result:=OldProc(window,msg,mp1,mp2);
END;

PROCEDURE TPaneWindowClass.ActiveToolbarButton(b:BOOLEAN);
VAR
    i:INTEGER;
BEGIN
    FOR i:=0 TO TBList.Count-1 DO BEGIN
        ToolButtonClass(TBList[i]).isActive:=b;
    END;
END;


constructor TabPaneWindowClass.Create(p:TPaneWindowClass;owner:hwnd);
BEGIN
    ParentClass:=p;
    TabMax:=-1;
END;

PROCEDURE TabPaneWindowClass.AddTab(FN:String;ID:INTEGER);
BEGIN
    Inc(TabMax);
    TabAry[TabMax].TabName:=FN;
    TabAry[TabMax].TabID:=id;
    ActiveTabIndex:=TabMax;
END;

PROCEDURE TabPaneWindowClass.DeleteTab(id:INTEGER);
VAR
    i,j:INTEGER;
BEGIN
    FOR i:=0 TO TabMax DO BEGIN
        IF TabAry[i].TabID=ID THEN BEGIN
            FOR j:=i+1 TO TabMax DO BEGIN
                TabAry[j-1]:=TabAry[j];
            END;
            Dec(TabMax);
        END;
    END;
END;

PROCEDURE TabPaneWindowClass.SetActive(id:INTEGER);
VAR
    i:INTEGER;
BEGIN
    FOR i:=0 TO TabMax DO BEGIN
        IF TabAry[i].TabID=ID THEN BEGIN
            ActiveTabIndex:=i;
        END;
    END;
END;

FUNCTION TabPaneWindowClass.DrawTab(ps:hps;rect:RectL;suffix:INTEGER):INTEGER;
VAR
    FixedLineWidth:Fixed;
    pt:PointL;
    TempRect:RectL;
    DrawWidth:INTEGER;
    FPAOut,FPAIn:ARRAY[1..5] OF pointL;
    roundHeight:INTEGER;
    BackColor,FontColor:ULong;
BEGIN
    IF Suffix=ActiveTabIndex THEN BEGIN
        FontColor:=CLR_BLACK;
        BackColor:=CLR_WHITE;
    END
    ELSE BEGIN
        FontColor:=CLR_BLACK;
        BackColor:=CLR_PaleGray;
    END;
    TempRect:=Rect;
    WinDrawText(PS,
               length(TabAry[Suffix].TabName),
               @TabAry[Suffix].TabName[1],
               TempRect,
               FontColor,
               BackColor,
               DT_QUERYEXTENT);
    RoundHeight:=(TempRect.yTop-TempRect.yBottom) div 4;
    DrawWidth:=TempRect.xRight-TempRect.xLeft
                +(DrawFrameWidth+DrawMargin)*2+RoundHeight;
    result:=DrawWidth;
    TempRect:=Rect;
    TempRect.xRight:=TempRect.xLeft+DrawWidth;
    TabAry[Suffix].Width:=DrawWidth;
    TabAry[Suffix].xLeft:=TempRect.xLeft;

    FPAOut[1].x:=TempRect.xLeft;
    FPAOut[1].y:=TempRect.yTop-(TabTopWidth+TabFrameWidth);
    FPAOut[2].x:=TempRect.xLeft;
    FPAOut[2].y:=TempRect.yBottom+TabFrameWidth+DrawFrameWidth;
    FPAOut[3].x:=TempRect.xLeft+DrawWidth-RoundHeight;
    FPAOut[3].y:=TempRect.yBottom+TabFrameWidth+DrawFrameWidth;
    FPAOut[4].x:=TempRect.xLeft+DrawWidth;
    FPAOut[4].y:=TempRect.yBottom+TabFrameWidth+DrawFrameWidth+RoundHeight;
    FPAOut[5].x:=FPAOut[4].x;
    FPAOut[5].y:=TempRect.yTop-(TabTopWidth+TabFrameWidth);

    FPAIn:=FPAOut;
    Dec(FPAIn[1].x,DrawFrameWidth);
    Dec(FPAIn[2].x,DrawFrameWidth);
    Dec(FPAIn[3].y,DrawFrameWidth);
    Dec(FPAIn[4].y,DrawFrameWidth);
    Dec(FPAIn[4].x,DrawFrameWidth);
    Dec(FPAIn[5].x,DrawFrameWidth);

    GpiSetLineWidth(ps,MakeFixed(DrawFrameWidth,0) );
    GpiSetColor(ps,BackColor);
    GpiBeginPath(Ps, 1);                  // create a path
    GpiMove(Ps, FPAIn[5]);
    GpiPolyLine(Ps, 5, FPAIn[1]);
    GpiEndPath(Ps);
    GpiFillPath(Ps, 1, fpath_Alternate);  // fill the path
    GpiSetColor(ps,CLR_WHITE);
    GpiMove(ps,FPAOut[1]);
    GpiLine(ps,FPAOut[2]);
    GpiSetColor(ps,CLR_DARKGRAY);
    GpiLine(ps,FPAOut[3]);
    Inc(FPAOut[3].y,DrawFrameWidth);
    Inc(FPAOut[3].x,DrawFrameWidth);
    GpiMove(ps,FPAOut[3]);
    GpiSetLineWidth(ps,MakeFixed(DrawFrameWidth*2,0) );
    GpiLine(ps,FPAOut[4]);
    GpiSetLineWidth(ps,MakeFixed(DrawFrameWidth,0) );
    GpiLine(ps,FPAout[5]);

    Inc(TempRect.xLeft,DrawMargin+DrawFrameWidth);
    TempRect.xRight:=TempRect.xLeft+DrawWidth-RoundHeight-DrawFrameWidth;
    Inc(TempRect.yBottom,DrawFrameWidth+TabFrameWidth+2);
    Dec(TempRect.yTop,TabTopPannelWIdth+TabFrameWidth+2);
    WinDrawText(PS,
               length(TabAry[Suffix].TabName),
               @TabAry[Suffix].TabName[1],
               TempRect,
               FontColor,
               BackColor,
               DT_LEFT OR DT_VCENTER OR DT_ERASERECT);
END;

PROCEDURE TabPaneWindowClass.RenameActiveTab(NewStr:string);
BEGIN
    TabAry[ActiveTabIndex].TabName:=NewStr;
    WinInvalidateRect(hwndTabPane,NIL,FALSE);
END;



FUNCTION TabPaneWindowClass.ClickTabNumber(pt:PointL):INTEGER;
VAR
    i:INTEGER;
BEGIN
    result:=-1;
    FOR i:=0 TO TabMax DO BEGIN
        IF (pt.x>TabAry[i].xLeft)
        AND (pt.x<(TabAry[i].xLeft+TabAry[i].width)) THEN BEGIN
            result:=i;
        END;
    END;

END;

PROCEDURE TabPaneWindowClass.DrawTabPane(window:hwnd);
VAR
    ps:hps;
    wRect,Rect:RectL;
    i:INTEGER;
    Pt:PointL;
BEGIN
    ps:=WinBeginPaint(window,0,@rect);
    WinQueryWindowRect(Window,rect);
    WinFillRect(ps,Rect,SYSCLR_MENU);

    pt.x:=0;
    pt.y:=Rect.yTop-TabFrameWidth;
    GpiMove(ps,pt);
    GpiSetColor(ps,CLR_WHITE);
    pt.x:=Rect.xRight;
    GpiLine(ps,pt);

    GpiSetLineWidth(ps,MakeFixed(TabTopPannelWidth ,0) );
    pt.x:=0;
    Dec(pt.y,TabTopPannelWidth);
    GpiMove(ps,pt);
    GpiSetColor(ps,SYSCLR_MENU);
    pt.x:=Rect.xRight;
    GpiLine(ps,pt);

    GpiSetLineWidth(ps,MakeFixed(TabFrameWidth,0) );
    pt.x:=Rect.xRight;
    pt.y:=Rect.yTop-TabTopWidth-TabFrameWidth;
    GpiMove(ps,pt);
    GpiSetColor(ps,CLR_DarkGray);
    pt.x:=0;
    GpiLine(ps,pt);
    pt.y:=0;
    GpiMove(ps,pt);
    GpiSetColor(ps,CLR_WHITE);
    pt.x:=Rect.xRight;
    GpiLine(ps,pt);

    GpiSetLineWidth(ps,MakeFixed(TabFrameWidth,0) );

    wRect:=Rect;
    wRect.xLeft:=TabFrameWidth+DrawMargin;
    FOR i:=0 TO TabMax DO BEGIN
        wRect.xLeft:=wRect.xLeft+DrawTab(ps,wRect,i);
    END;
    WinEndPaint(ps);
END;


FUNCTION ToolButtonProc(Window:HWnd;
                        Msg:ULong;
                        mp1,mp2: MParam):mResult;cdecl;
VAR
    ToolButton:ToolButtonClass;
BEGIN
    ToolButton:=ToolButtonClass(WinQueryWindowULONG( window, QWL_USER ));
    result:=ToolButton.TBHandler(window,msg,mp1,mp2);
END;


FUNCTION ToolButtonClass.TBHandler(window:hwnd;Msg:ULong;Mp1,Mp2:MParam):MResult;
VAR
    HPSTemp:hps;
    rclButton:RectL;
    isPop:BOOLEAN;
    hwndOwner:hwnd;

    ulStyle    :ULong;
    hwndBubbleClient:HWND;
    ptlWork,PrevPoint:PointL;
    ulColor:ULong;
    txtPointl  :ARRAY [0..TXTBOX_COUNT-1] OF POINTL;
    lHight,
    lWidth     :LONGINT;
    PROCEDURE DrawFrame(isPop:BOOLEAN;rect:RectL);
    VAR
        UpperFrameColor,DownFrameColor:ULong;
        wRect:RectL;
    BEGIN
        IF isPop THEN BEGIN
            DownFrameColor:=CLR_DARKGRAY;
            UpperFrameColor:=CLR_WHITE;
        END
        ELSE BEGIN
            DownFrameColor:=CLR_WHITE;
            UpperFrameColor:=CLR_DARKGRAY;
        END;
        wRect:=Rect;
        rect.xRight:=rect.xLeft+ButtonDepth;
        WinFillRect(HPSTemp,rect,UpperFrameColor);

        Rect:=wRect;
        rect.yBottom:=rect.yTop-ButtonDepth;
        WinFillRect(HPSTemp,rect,UpperFrameColor);

        Rect:=wRect;
        rect.xLeft:=rect.xRight-ButtonDepth;
        WinFillRect(HPSTemp,rect,DownFrameColor);

        Rect:=wRect;
        rect.yTop:=rect.yBottom+ButtonDepth;
        WinFillRect(HPSTemp,rect,DownFrameColor);
    END;

    FUNCTION isRectIn:BOOLEAN;
    VAR
        mCx,mCy:INTEGER;
    BEGIN
        mCx:=SHORT1FROMMP(mp1);
        mCy:=SHORT2FROMMP(mp1);
        IF (RclButton.yBottom<mCy) AND (rclButton.yTop>mCy) AND
           (rclButton.xLeft<mCx) AND (rclButton.xRight>mCx)
        THEN
            isRectIn:=TRUE
        ELSE
            isRectIn:=FALSE;
    END;

BEGIN
    IF isActive=FALSE THEN BEGIN
        result:=ToolbarOldProc( window,Msg,mp1,mp2);
        EXIT;
    END;
    CASE Msg OF
        wm_mousemove:BEGIN
            WinQueryWindowRect(Window,rclButton);
            IF isRectIn THEN BEGIN
                IF isCapture = FALSE THEN BEGIN
                    WinSetCapture(HWND_DESKTOP,Window);
                    isCapture :=TRUE;
                END;
                IF isHilight=FALSE THEN BEGIN
                    isHilight:=TRUE;
                    HPSTemp:=WinGetPS(Window);
                    DrawFrame(true,rclButton);
                    WinReleasePS(HPSTemp);
                END;
                IF (PW.hwndBubble=0 ) AND
                   (isStartTimer=FALSE) AND
                   (PW.BubbleClient<>Window)
                THEN BEGIN
                    WinStartTimer(WinQueryAnchorBlock(Window),
                                  Window,
                                  WidgetTimerID+NuID,700);
                    isStartTimer:=TRUE;
                END;
            END
            ELSE BEGIN
                IF isStartTimer THEN
                    WinStopTimer(WinQueryAnchorBlock(Window),
                                  Window,
                                  WidgetTimerID+NuID);
                isStartTimer:=FALSE;
                IF PW.hwndBubble<>0 THEN BEGIN
                    WinDestroyWindow(PW.hwndBubble);
                    PW.hwndBubble:=0;
                    PW.BubbleClient:=Window;
                    HPSTemp:=WinGetPS(Window);
                    DrawFrame(true,rclButton);
                    WinReleasePS(HPSTemp);
                END;

                IF isCapture THEN BEGIN
                    WinSetCapture(HWND_DESKTOP,NULLHANDLE);
                    isCapture :=FALSE;
                END;
                IF isHilight THEN BEGIN
                    isHilight:=FALSE;
                    WinSendMsg(Window,
                               SM_SETHANDLE,
                               WinSendMsg(window,SM_QUERYHANDLE,0,0),
                               0);

                END;
            END;
        END;(**mousemove**)
        WM_TIMER:BEGIN
            IF isStartTimer THEN
                WinStopTimer(WinQueryAnchorBlock(Window),
                             Window,
                             WidgetTimerID+NuID);
            isStartTimer:=FALSE;

            WinQueryWindowRect(Window,rclButton);
            ulStyle:=FCF_BORDER OR FCF_NOBYTEALIGN;
            hpsTemp:=0;
            ptlWork.x:=0;
            ptlWork.y:=0;
            ulColor:=CLR_PALEGRAY;
            WinQueryPointerPos(HWND_DESKTOP,PrevPoint);

            PW.hwndBubble:=WinCreateStdWindow( HWND_DESKTOP,
                                                    0,
                                                    ulStyle,
                                                    WC_STATIC,
                                                    '',
                                                    SS_TEXT OR
                                                    DT_LEFT OR
                                                    DT_VCENTER,
                                                    NULLHANDLE,
                                                    TB_BUBBLEID,
                                                    @hwndBubbleClient);

            WinSetPresParam(hwndBubbleClient,
                            PP_FONTNAMESIZE,
                            strlen(ppFont)+1,
                            ppFont);
            WinSetPresParam(hwndBubbleClient,
                            PP_BACKGROUNDCOLORINDEX,
                            sizeof(
                            ulColor),@ulColor);

            WinSetWindowText(hwndBubbleClient, @(cText[1]));

            WinMapWindowPoints(Window, HWND_DESKTOP, ptlWork, 1);

            hpsTemp:=WinGetPS(hwndBubbleClient);
            GpiQueryTextBox(hpsTemp,
                            Length(cText)-1,
                            @cText[1],
                            TXTBOX_COUNT,PPOINTL(@txtPointl[0])^);

            WinReleasePS(hpsTemp);

            lWidth:=txtPointl[TXTBOX_TOPRIGHT].x-
                    txtPointl[TXTBOX_TOPLEFT].x+
                    WinQuerySysValue(HWND_DESKTOP,SV_CYDLGFRAME)*2;

            lHight:=txtPointl[TXTBOX_TOPLEFT].y-
                    txtPointl[TXTBOX_BOTTOMLEFT].y+
                    WinQuerySysValue(HWND_DESKTOP,SV_CXDLGFRAME)*2;

            Dec(ptlWork.y,lHight);

            WinSetWindowPos(PW.hwndBubble,
                            HWND_TOP,
                            ptlWork.x,
                            ptlWork.y,
                            lWidth,
                            lHight,
                            SWP_SIZE OR SWP_MOVE OR SWP_SHOW);
        END;(**wm_timer**)
        WM_BUTTON1DOWN:BEGIN
            HPSTemp:=WinGetPS(Window);
            WinQueryWindowRect(Window,rclButton);
            DrawFrame(FALSE,rclButton);
            WinReleasePS(HPSTemp);
        END;
        WM_BUTTON1UP:BEGIN
            WinSendMsg(Window,
                       SM_SETHANDLE,
                       WinSendMsg(window,SM_QUERYHANDLE,0,0),
                       0);
            hwndOwner:=WinQueryWindow(Window,QW_OWNER);
            WinPostMsg(hwndFrame,
                       WM_COMMAND,
                       NuID,
                       MPFROM2SHORT(NuID,CMDSRC_OTHER));
        END;

        ELSE
            result := ToolbarOldProc( window,Msg,mp1,mp2);
    END;
END;



constructor ToolButtonClass.Create(rcID:ULong;st:string;OwnerWnd:hwnd;xPos:INTEGER);
VAR
    cButtText :string;
    hwndButton:hwnd;
BEGIN
    IF rcID<>TB_SEPARATOR THEN BEGIN
        cButtText:='#'+IntToStr(rcID)+#0;
        hwndButton:=WinCreateWindow(OwnerWnd,
                                WC_STATIC,
                                @cButtText[1],
                                SS_BITMAP OR WS_VISIBLE,
                                xPos,
                                0,
                                TBSize,
                                TBSize,
                                OwnerWnd,
                                HWND_TOP,
                                rcID,
                                NIL,
                                NIL);

        isHilight:=FALSE;
        isCapture:=FALSE;
        isStartTimer:=FALSE;
        isActive:=TRUE;
        NuID:=rcID;
        cText:=St+#0;
        Window:=hwndButton;
        @ToolbarOldProc:=WinSubclassWindow(hwndButton,ToolButtonProc);
        WinSetWindowULong(hwndButton,QWL_USER,ULong(self));
    END
    ELSE BEGIN
        hwndButton:=WinCreateWindow(OwnerWnd,
                                WC_STATIC,
                                '#384',
                                SS_BITMAP OR WS_VISIBLE,
                                xPos,
                                0,
                                8,
                                TBSize,
                                OwnerWnd,
                                HWND_TOP,
                                rcID,
                                NIL,
                                NIL);
    END;
END;


BEGIN
END.


